# MoveTo Action

This **Node** has different versions for [**Scenes**](/incari-studio/objects-and-types/project-objects/scene.md) and [**Scene2Ds**](/incari-studio/objects-and-types/project-objects/scene2d.md). Find in the tabs below the documentation for both versions.

{% tabs %}
{% tab title="Scene" %}
**Overview**

![The MoveTo Action Node.](/files/qmRDZhhZNt9AbDiXxORy)

The **MoveTo Action Node** continuously modifies the `Position` of a [**Scene Object**](/incari-studio/objects-and-types/scene-objects.md) to the values specified in `To` for a given period of time, thus creating an **Animation**.

Furthermore, visit the [**Actions Nodes**](/incari-studio/toolbox/actions.md) page for a general introduction to these **Nodes**, and [**Position**](/incari-studio/objects-and-types/attributes/common-attributes/transformation.md#position) for more detail about the `Position` **Attribute**.

[**Scope**](/incari-studio/toolbox/overview.md#scopes): **Scene**, **Function**, **Prefab**.

**Attributes**

![The MoveTo Action Node Attributes.](/files/FlTFLCFqopRr1tNgs6ei)

| Attribute        | Type          | Description                                                                                                                                                                                                                                                                                                                                 |
| ---------------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `To`             | **Vector3**   | The desired `Position` along the X, Y, Z axes, if none is received in the `To` **Input Socket**.                                                                                                                                                                                                                                            |
| `Duration (sec)` | **Float**     | The total time of the **Action**, if none is received in the `Duration` **Input Socket**.                                                                                                                                                                                                                                                   |
| `Interpolation`  | **Drop-down** | The `Interpolation` method to use for calculating the intermediate values of the `Position`. It can be [*Linear*](https://en.wikipedia.org/wiki/Linear_interpolation), [*Sine Ease In*](https://easings.net/#easeInSine), [*Sine Ease In Out*](https://easings.net/#easeInOutSine), or [*Sine Ease Out*](https://easings.net/#easeOutSine). |

**Inputs**

| Input         | Type           | Description                                                                                                                                                                 |
| ------------- | -------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `Instance ID` | **InstanceID** | The assigned [**Instance ID**](/incari-studio/toolbox/actions.md#instance-id) of the **Action**. If nothing is received, it automatically assigns 0 as the **Instance ID**. |
| (►) `Start`   | **Pulse**      | A standard **Input Pulse**, to trigger the execution of the **Node**.                                                                                                       |
| `Object ID`   | **ObjectID**   | The ID of the target **Object**.                                                                                                                                            |
| `Duration`    | **Float**      | The total time (in seconds).                                                                                                                                                |
| `To`          | **Vector3**    | The desired final `Position` along the X, Y, Z axes.                                                                                                                        |

**Outputs**

| Output        | Type           | Description                                                                                      |
| ------------- | -------------- | ------------------------------------------------------------------------------------------------ |
| `Instance ID` | **InstanceID** | The assigned [**Instance ID**](/incari-studio/toolbox/actions.md#instance-id) of the **Action**. |
| `OnStart` (►) | **Pulse**      | Flows to the next **Node** following **MoveTo Action** when the **Action** starts.               |
| `OnEnd` (►)   | **Pulse**      | Flows to the next **Node** following **MoveTo Action** when the **Action** stops.                |
| {% endtab %}  |                |                                                                                                  |

{% tab title="Scene2D" %}
**Overview**

![The MoveTo Action Node.](/files/xC1HxRr8uQVk8wFlTo4S)

The **MoveTo Action Node** continuously modifies the `Position` of an [**Scene2D Object**](/incari-studio/objects-and-types/scene2d-objects.md) to the values specified in `To` for a given period of time, thus creating an **Animation**.

Furthermore, visit the [**Actions Nodes**](/incari-studio/toolbox/actions.md) page for a general introduction to these **Nodes**, and [**Position**](/incari-studio/objects-and-types/attributes/common-attributes/transformation.md#position) for more detail about the `Position` **Attribute**.

[**Scope**](/incari-studio/toolbox/overview.md#scopes): **Scene**, **Function**, **Prefab**.

**Attributes**

![The MoveTo Action Node Attributes.](/files/eGnUow710iaunxbJLBoW)

| Attribute        | Type          | Description                                                                                                                                                                                                                                                                                                                                 |
| ---------------- | ------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `To`             | **Vector2**   | The desired `Position` along the X and Y axes, if none is received in the `To` **Input Socket**.                                                                                                                                                                                                                                            |
| `Duration (sec)` | **Float**     | The total time of the **Action**, if none is received in the `Duration` **Input Socket**.                                                                                                                                                                                                                                                   |
| `Interpolation`  | **Drop-down** | The `Interpolation` method to use for calculating the intermediate values of the `Position`. It can be [*Linear*](https://en.wikipedia.org/wiki/Linear_interpolation), [*Sine Ease In*](https://easings.net/#easeInSine), [*Sine Ease In Out*](https://easings.net/#easeInOutSine), or [*Sine Ease Out*](https://easings.net/#easeOutSine). |

**Inputs**

| Input         | Type           | Description                                                                                                                                                                 |
| ------------- | -------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `Instance ID` | **InstanceID** | The assigned [**Instance ID**](/incari-studio/toolbox/actions.md#instance-id) of the **Action**. If nothing is received, it automatically assigns 0 as the **Instance ID**. |
| (►) `Start`   | **Pulse**      | A standard **Input Pulse**, to trigger the execution of the **Node**.                                                                                                       |
| `Object ID`   | **ObjectID**   | The ID of the target **Object**.                                                                                                                                            |
| `Duration`    | **Float**      | The total time (in seconds).                                                                                                                                                |
| `To`          | **Vector2**    | The desired final `Position` along the X and Y axes.                                                                                                                        |

**Outputs**

| Output        | Type           | Description                                                                                      |
| ------------- | -------------- | ------------------------------------------------------------------------------------------------ |
| `Instance ID` | **InstanceID** | The assigned [**Instance ID**](/incari-studio/toolbox/actions.md#instance-id) of the **Action**. |
| `OnStart` (►) | **Pulse**      | Flows to the next **Node** following **MoveTo Action** when the **Action** starts.               |
| `OnEnd` (►)   | **Pulse**      | Flows to the next **Node** following **MoveTo Action** when the **Action** stops.                |
| {% endtab %}  |                |                                                                                                  |
| {% endtabs %} |                |                                                                                                  |

## Example

This section shows a simple example of how to use the **MoveTo Action** **Node** and the effect it has on an **Scene Object**. This concept can be applied as well to a **Scene2D Object**.

We start by [configuring the **Scene**](#scene-configuration), then [build the **Logic**](#logic), and finally show the [result](#final-result).

### Scene Configuration

We consider a [**Scene**](/incari-studio/objects-and-types/project-objects/scene.md) with two [**Objects**](/incari-studio/objects-and-types/scene-objects.md): a red arc over a black background, both of which can be easily created in the [**Scene Outliner**](/incari-studio/modules/scene-outliner.md). Then, we set the `Size` **Attribute** of the arc to $$(150, 150, 1)$$. See this configuration in the following image:

![Scene configuration.](/files/pbqt5W3gtk8BLJvZxgZC)

### Logic

We then need to configure the **Logic**. This is done in the [**Logic Editor**](/incari-studio/modules/logic-editor.md).

We use the **MoveBy Action** **Node** with the following **Attributes**:

* `To`: $$(150, 150, 0)$$
* `Duration (sec)`: $$3$$
* `Interpolation`: `Linear`

And we connect to it the [**Object Node**](/incari-studio/objects-and-types/scene-objects.md#objects-in-the-logic) of the red arc and a **Pulse** to the `Start` **Input Socket**. Thus, having the following **Logic** configuration:

![Logic configuration.](/files/26kAw0h3hEwJ7QuPX6Kk)

### Final result

Finally, the effect of the **ScaleTo Action** **Node** when triggered is the following:

![Final result.](/files/I00epR2q0bXfNDSsosZU)

## See Also

* [**MoveBy Action**](/incari-studio/toolbox/actions/movebyaction.md)

## External Links

* [*Position (geometry)*](https://en.wikipedia.org/wiki/Position_\(geometry\)) on Wikipedia.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.incari.com/incari-studio/toolbox/actions/movetoaction.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
